//---------------------------------------------------------------------------

#include <vcl.h>
#include <sys\stat.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <dir.h>
#pragma hdrstop

#include "MainUnit.h"
#include "Run/Func.h"

#include "SettingUnit.h"
#include "Public.h"
#include "AboutUnit.h"
#include "RegisterUnit.h"
#include "ProcessUnit.h"

//#define HY_Test
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
        m_IncFlag=false;
        m_DecFlag=false;
        m_FileOpenFlag=false;
        m_CancelFlag=false;
}
//---------------------------------------------------------------------------
//ΪʵϢ
void __fastcall TMainForm::MessageProcess(TMessage Message)
{
        long lReadData;
        #ifdef HY_Test
        Byte WriteBuf[16]={0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f};
        Byte pBuf[6]={0xff,0xff,0xff,0xff,0xff,0xff};
        #endif

        Timer_Timeout->Enabled=false;
        ProcessTimer->Enabled=false;

        //ֱͨϢṹݲ
        Byte iCMD=(Byte)Message.WParam;
        Byte *pData=(Byte *)Message.LParam;

        Byte iStatus=pData[0];
        Byte iDataLen=pData[1];
        Byte iCardType;
        #ifdef HY_Debug
        Memo_Output->Lines->Add("CMD: "+IntToStr(iCMD));
        Memo_Output->Lines->Add("Status: "+IntToStr(iStatus));
        Memo_Output->Lines->Add("DataLen: "+IntToStr(iDataLen));
        #endif
        switch (iCMD)
        {
                case 0x14:
                        Memo_Output->Lines->Add("Read Mifare card command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                break;
                case 0x15:
                        //Memo_Output->Lines->Add("Write Mifare card command execution.");
                        m_ReSendCount++;
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        else if (m_ReSendCount >1)
                            Memo_Output->Lines->Add("Write OK.");
                        else HYMIFARE_WriteData(250,m_TestBuf,250);
                return;
                case CMD_SelectCard:
                        #ifdef HY_Test
                        HYMIFARE_LoginSector(m_Sector,m_Type,pBuf);
                        m_WriteBlock=m_Sector*3+m_Sector;
                        #else
                        Memo_Output->Lines->Add("Select Mifare card command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (iDataLen ==4)
                        {
                                Memo_Output->Lines->Add("Serial num : "+IntStrToHexString(pData+2,iDataLen));
                                Label_CardType->Caption="The card type is Mifare Standard Card.";
                                /*
                                Panel_MifarePro->Align =alNone;
                                Panel_MifarePro->Left =-1000;
                                Panel_SmartCard->Align =alNone;
                                Panel_SmartCard->Left =-1000;
                                Panel_Mifare->Align =alClient;*/
                                Panel_Mifare->Enabled =true;
                                TreeView_Read->Enabled=true;
                        }
                        else if (iDataLen ==5)
                        {
                                Memo_Output->Lines->Add("Serial num : "+IntStrToHexString(pData+2,iDataLen-1));
                                iCardType=pData[iDataLen+1];
                                #ifdef HY_Debug
                                Memo_Output->Lines->Add("CardType: "+IntToStr(iCardType));
                                #endif
                                if (iCardType==0x01)
                                {
                                        Label_CardType->Caption="The card type is Mifare Standard Card.";
                                        /*
                                        Panel_MifarePro->Align =alNone;
                                        Panel_MifarePro->Left =-1000;
                                        Panel_SmartCard->Align =alNone;
                                        Panel_SmartCard->Left =-1000;
                                        Panel_Mifare->Align =alClient;*/
                                        Panel_Mifare->Enabled =true;
                                        TreeView_Read->Enabled=true;
                                }
                                else if(iCardType==0x02)
                                {
                                        Label_CardType->Caption="The card type is Mifare PRO Card.";
                                        /*
                                        Panel_Mifare->Align =alNone;
                                        Panel_Mifare->Left =-1000;
                                        Panel_SmartCard->Align =alNone;
                                        Panel_SmartCard->Left =-1000;    */
                                        Panel_Mifare->Enabled =false;
                                        TreeView_Read->Enabled=false;
                                        /*
                                        Panel_MifarePro->Left =1;
                                        Panel_MifarePro->Align =alClient;*/
                                }
                        }
                        #endif
                return;
                case CMD_RequestMifareCard:
                     if (iStatus == 0)
                     {
                        Memo_Output->Lines->Add("Request Mifare card success.");
                        Memo_Output->Lines->Add("ATQA : "+IntStrToHexString(pData+2,iDataLen));
                        return;
                     }
                     else
                     {
                                ShowErrorMessage(iStatus);
                                return;
                     }
                case CMD_AutoLogin:
                        if (iStatus !=0x02)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        Memo_Output->Lines->Add("Auto login to a sector success.");
                break;
                case CMD_LoginWithKeyStored:
                        if (iStatus !=0x02)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        Memo_Output->Lines->Add("login to a sector success with key stored.");
                break;
                case CMD_StoreKey:
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        Memo_Output->Lines->Add("Store key success.");
                break;
                case CMD_ChangeBaudRate:
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                m_EnterISPFlag=false;
                                return;
                        }
                        Memo_Output->Lines->Add("Change baud rate success.");
                break;
                case CMD_LoginToSector:
                        if (iStatus !=0x02)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        Memo_Output->Lines->Add("Login to a sector success.");
                        #ifdef HY_Test
                        HYMIFARE_WriteDataBlock(m_WriteBlock,WriteBuf);
                        m_WriteBlock++;
                        #endif
                break;
                case CMD_ReadDataBlock:
                        Memo_Output->Lines->Add("Read a data block command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                break;
                case CMD_WriteDataBlock:
                        Memo_Output->Lines->Add("Write a data block command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        #ifdef HY_Test
                        if (m_WriteBlock==(m_Sector*3+m_Sector+3))
                        {
                                m_Sector++;
                                HYMIFARE_SelectCard();
                        }
                        else
                        {
                                HYMIFARE_WriteDataBlock(m_WriteBlock,WriteBuf);
                                m_WriteBlock++;
                        }
                        #endif
                break;
                case CMD_ReadValueBlock:
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (m_IncFlag)
                        {
                                m_IncFlag=false;
                                if (iDataLen!=0)
                                {
                                        lReadData=JoinLenBuf(pData+2);
                                        if ((lReadData+m_WriteData)>=1000)
                                        {
                                                Memo_Output->Lines->Add("Increment is not allowed.");
                                                return;
                                        }
                                        HYMIFARE_IncrementValue(m_IncrementBlock,m_WriteBuffer);
                                }
                                return;
                        }
                        if (m_DecFlag)
                        {
                                m_DecFlag=false;
                                if (iDataLen!=0)
                                {
                                        lReadData=JoinLenBuf(pData+2);
                                        if ( (lReadData<=0)||((lReadData+m_WriteData)<=0) )
                                        {
                                                Memo_Output->Lines->Add("Decrement is not allowed.");
                                                return;
                                        }
                                        HYMIFARE_DecrementValue(m_DecrementBlock,m_WriteBuffer);
                                }
                                return;
                        }
                        Memo_Output->Lines->Add("read a value block command execution.");
                        if (iDataLen!=0)
                        {
                                long lData=JoinLenBuf(pData+2);
                                Memo_Output->Lines->Add("Read value: "+IntToStr(lData));
                        }
                return;
                case CMD_WriteValueBlock:
                        Memo_Output->Lines->Add("Write a value block command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (iDataLen!=0)
                        {
                                long lData=JoinLenBuf(pData+2);
                                Memo_Output->Lines->Add("Write value: "+IntToStr(lData));
                        }
                return;
                case CMD_WriteMasterKey:
                        Memo_Output->Lines->Add("Write master key command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                break;
                case CMD_IncrementValue:
                        Memo_Output->Lines->Add("Increment value command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (iDataLen!=0)
                        {
                                long lData=JoinLenBuf(pData+2);
                                Memo_Output->Lines->Add("Current value: "+IntToStr(lData));
                        }
                return;
                case CMD_DecrementValue:
                        Memo_Output->Lines->Add("Decrement value command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (iDataLen!=0)
                        {
                                long lData=JoinLenBuf(pData+2);
                                Memo_Output->Lines->Add("Current value: "+IntToStr(lData));
                        }
                return;
                case CMD_CopyValue:
                        Memo_Output->Lines->Add("Copy value command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                break;
                case CMD_Halt:
                        Memo_Output->Lines->Add("Halt command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                break;
                case CMD_ContinuousRead:
                        Memo_Output->Lines->Add("Continuous read command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                break;
                case CMD_Reset:
                        Memo_Output->Lines->Add("Reset command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                break;
                case CMD_GetATS:
                        Memo_Output->Lines->Add("Get ATS command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (iDataLen !=0)
                                Edit_ATS->Text=IntStrToHexString(pData+2,iDataLen);
                return;
                case CMD_Deselect:
                        Memo_Output->Lines->Add("Deselect command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                return;
                case CMD_ExchangeAPDU:
                        Memo_Output->Lines->Add("Exchange APDU command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (iDataLen !=0)
                                Edit_APDUReturn->Text=IntStrToHexString(pData+2,iDataLen);
                return;
                case CMD_SmartCardPowerUp:
                        Memo_Output->Lines->Add("Power up command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (iDataLen !=0)
                                Edit_SmartCardATR->Text=IntStrToHexString(pData+2,iDataLen);
                return;
                case CMD_SmartCardPowerDown:
                        Memo_Output->Lines->Add("Power down command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                break;
                case CMD_SmartCardExchangeAPDU:
                        Memo_Output->Lines->Add("Exchange APDU command execution.");
                        if (iStatus !=0)
                        {
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (iDataLen !=0)
                                Edit_SmartCardAPDUReturn->Text=IntStrToHexString(pData+2,iDataLen);
                return;
                case CMD_IOOutput:
                        Memo_Output->Lines->Add("IO-output command execution.");
                        if (iStatus !=0)
                                ShowErrorMessage(iStatus);
                return;
                case CMD_EnterISP:
                        if (m_CancelFlag)
                        {
                                m_CancelFlag=false;
                                Memo_Output->Lines->Add("To be Canceled");
                                return;
                        }
                        #ifdef HY_Debug
                        Memo_Output->Lines->Add("Enter ISP command execution.");
                        #endif
                        if (iStatus !=0)
                        {
                                if (ProcessForm!=NULL)
                                {
                                        ProcessForm->Close();
                                }
                                ShowErrorMessage(iStatus);
                                return;
                        }
                        if (m_SerialPort.Baud_Idx!=BAUDR_57600)
                        {
                             SetBaud(BAUDR_57600);
                             //m_SerialPort.Baud_Idx=BAUDR_57600;
                             //StatusBar_Main->Panels->Items[1]->Text="57600";
                        }
                        Sleep(500);
                        if (HYMIFARE_ChipErase())
                        {
                                #ifdef HY_Debug
                                Memo_Output->Lines->Add("Send chip-erase command success.");
                                #endif
                                ProcessTimer->Enabled=true;
                                Timer_Timeout->Enabled=true;
                        }
                        else
                        {
                                if (ProcessForm!=NULL)
                                {
                                        ProcessForm->Close();
                                }
                                Memo_Output->Lines->Add("Send chip-erase command fail.");
                        }
                return;
                case CMD_ByteProgram:
                if (m_CancelFlag)
                {
                        m_CancelFlag=false;
                        Memo_Output->Lines->Add("To be Canceled");
                        return;
                }
                //Memo_Output->Text = Memo_Output->Text + ". ";
                switch (m_CriticalDownload.DownloadState)
                {
                        case DOWNLOAD_FINISHED:
                        if (ProcessForm!=NULL)
                        {
                                ProcessForm->Close();
                        }
                        Memo_Output->Lines->Add("Program Success!");
                        m_CriticalDownload.DownloadState=DOWNLOAD_CONTINUE;
                        if (HYMIFARE_ChipProtect())
                        {
                                #ifdef HY_Debug
                                Memo_Output->Lines->Add("Chip-protect command send success.");
                                #endif
                                Timer_Timeout->Enabled=true;
                        }
                        else
                                Memo_Output->Lines->Add("Chip-protect command send fail.");
                        return;
                        case DOWNLOAD_LASTBYTE:
                        if (!HYMIFARE_ByteProgram(0,m_CriticalDownload.DownloadBuffer,1))
                        {
                                if (ProcessForm!=NULL)
                                {
                                        ProcessForm->Close();
                                }
                                Memo_Output->Lines->Add("Program Fail.");
                                m_CriticalDownload.DownloadState=DOWNLOAD_CONTINUE;
                        }
                        else
                        {
                                m_CriticalDownload.DownloadState=DOWNLOAD_FINISHED;
                                Timer_Timeout->Enabled=true;
                                if (ProcessForm!=NULL)
                                {
                                        ProcessForm->ProcessProgressBar->StepBy(250);
                                        ProcessForm->Update();
                                }
                        }
                        return;
                        case DOWNLOAD_CONTINUE:
                        if (m_CriticalDownload.DownloadRemainSize > 250)
                        {
                                m_CriticalDownload.DownloadRemainSize -=250;
                                m_CriticalDownload.DownloadingSize=250;
                                if (!HYMIFARE_ByteProgram(m_CriticalDownload.DownloadOffset,
                                        m_CriticalDownload.DownloadBuffer +
                                        m_CriticalDownload.DownloadOffset,
                                        m_CriticalDownload.DownloadingSize))
                                {
                                        if (ProcessForm!=NULL)
                                        {
                                                ProcessForm->Close();
                                        }
                                        Memo_Output->Lines->Add("Program Fail.");
                                }
                                else
                                {
                                        m_CriticalDownload.DownloadOffset += 250;
                                        #ifdef HY_Debug
                                        Memo_Output->Lines->Add("Offset="+
                                                IntToStr(m_CriticalDownload.DownloadOffset));
                                        #endif
                                        Timer_Timeout->Enabled=true;
                                        if (ProcessForm!=NULL)
                                        {
                                                ProcessForm->ProcessProgressBar->StepBy(250);
                                                ProcessForm->Update();
                                        }
                                }
                        }
                        else// <=250
                        {
                                if (!HYMIFARE_ByteProgram(m_CriticalDownload.DownloadOffset,
                                        m_CriticalDownload.DownloadBuffer +
                                        m_CriticalDownload.DownloadOffset,
                                        m_CriticalDownload.DownloadRemainSize))
                                {
                                        if (ProcessForm!=NULL)
                                        {
                                                ProcessForm->Close();
                                        }
                                        Memo_Output->Lines->Add("Program Fail.");
                                }
                                else
                                {
                                        m_CriticalDownload.DownloadState=DOWNLOAD_LASTBYTE;
                                        Timer_Timeout->Enabled=true;
                                        #ifdef HY_Debug
                                        Memo_Output->Lines->Add("Offset="+
                                                IntToStr(m_CriticalDownload.DownloadOffset));
                                        #endif
                                        #ifdef HY_Debug
                                        Memo_Output->Lines->Add("Remain="+
                                                IntToStr(m_CriticalDownload.DownloadRemainSize));
                                        #endif
                                        if (ProcessForm!=NULL)
                                        {
                                                ProcessForm->ProcessProgressBar->StepBy(250);
                                                ProcessForm->Update();
                                        }
                                }
                        }
                }
                return;
                case CMD_ChipProtect:
                #ifdef HY_Debug
                Memo_Output->Lines->Add("chip-protect success.");
                #endif
                if (HYMIFARE_Reset())
                {
                        #ifdef HY_Debug
                        Memo_Output->Lines->Add("Reset command send success.");
                        #endif
                        Timer_Timeout->Enabled=true;
                }
                else
                        Memo_Output->Lines->Add("Reset command send fail.");
                SetBaud(m_SerialPort.Baud_Idx);
                return;
                case CMD_PageErase:
                #ifdef HY_Debug
                Memo_Output->Lines->Add("page-erase success.");
                #endif
                return;
                case CMD_ChipErase:
                if (m_CancelFlag)
                {
                        m_CancelFlag=false;
                        Memo_Output->Lines->Add("To be Canceled");
                        return;
                }
                #ifdef HY_Debug
                Memo_Output->Lines->Add("chip-erase success.");
                #endif
                m_CriticalDownload.DownloadingSize=m_CriticalDownload.DownloadSize;
                if (m_CriticalDownload.DownloadingSize <= 250)
                {
                        if (!HYMIFARE_ByteProgram(0,
                                m_CriticalDownload.DownloadBuffer,
                                m_CriticalDownload.DownloadingSize))
                        {
                                if (ProcessForm!=NULL)
                                {
                                        ProcessForm->Close();
                                }
                                Memo_Output->Lines->Add("Program Fail.");
                                return;
                        }
                        m_CriticalDownload.DownloadState=DOWNLOAD_FINISHED;
                        Timer_Timeout->Enabled=true;
                }
                else// file size > 250
                {
                        m_CriticalDownload.DownloadRemainSize=
                                m_CriticalDownload.DownloadingSize-250;

                        m_CriticalDownload.DownloadingSize=250;
                        m_CriticalDownload.DownloadOffset=1;

                        if (!HYMIFARE_ByteProgram(m_CriticalDownload.DownloadOffset,
                                m_CriticalDownload.DownloadBuffer +
                                m_CriticalDownload.DownloadOffset,
                                m_CriticalDownload.DownloadingSize))
                        {
                                if (ProcessForm!=NULL)
                                {
                                        ProcessForm->Close();
                                }
                                Memo_Output->Lines->Add("Program Fail.");
                                return;
                        }
                        m_CriticalDownload.DownloadOffset += 250;
                        m_CriticalDownload.DownloadState=DOWNLOAD_CONTINUE;
                        Timer_Timeout->Enabled=true;
                        #ifdef HY_Debug
                        Memo_Output->Lines->Add("Offset="+IntToStr(m_CriticalDownload.DownloadOffset));
                        #endif
                        if (ProcessForm!=NULL)
                        {
                                ProcessForm->Lb_Caption->Caption="Programming,Please wait...";
                                ProcessForm->ProcessProgressBar->StepBy(250);
                                ProcessForm->Update();
                        }
                }
                return;
                case CMD_ByteVerify:
                #ifdef HY_Debug
                Memo_Output->Lines->Add("byte-verify success.");
                #endif
                return;
                case EVENT_CHECKSUM_ERROR:
                        m_EnterISPFlag=false;
                        Memo_Output->Lines->Add("Checksum error.");
                return;
                default:
                        m_EnterISPFlag=false;
                        Memo_Output->Lines->Add("Unknown error.");
                return;
        }
        if (iDataLen!=0)
                Memo_Output->Lines->Add("Respond data : "+IntStrToHexString(pData+2,iDataLen));
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdatefirmwareClick(TObject *Sender)
{
        char filepath[100];
        AnsiString FileName;
        Byte HengYu[16]={0x7B,0xAB,0x1B,0x8B,0x6A,0xAA,0x3B,0xBA,0xBB,0xFA,0xDA,0x0B,0xBB,0xAA,0xCB,0x00}; //0xBA -> 0x00

        OpenDlg_DownFile->InitialDir=m_OpenFilePath;

        if(OpenDlg_DownFile->Execute())
        {
                Memo_Output->Lines->Add("Load file...");
                FileName=OpenDlg_DownFile->FileName;
                Memo_Output->Lines->Add(FileName);
                strcpy(filepath,FileName.c_str());

                _fmode = O_BINARY;

                int handle=open(filepath,O_BINARY|O_RDONLY);
                if (handle==-1)
                {
                      close(handle);
                      Memo_Output->Lines->Add("Open File Error.");
                      return ;
                }
                long FileSize=filelength(handle);
                #ifdef HY_Debug
                Memo_Output->Lines->Add("FileSize=0x"+IntToHex((int)FileSize,4));
                #endif

                if (FileSize < 0xF7FF)
                {
                        Memo_Output->Lines->Add("File Error.");
                        close(handle);
                        return;
                }
                if (FileSize != 0xF7FF)
                        FileSize=0xF7FF;
                Byte *pFileBuf=(Byte *)malloc(FileSize);
                if (pFileBuf==NULL)
                {
                        Memo_Output->Lines->Add("Not enough memory to allocate buffer.");
                        close(handle);
                        return;
                }
                FileSize=read(handle,pFileBuf,FileSize);
                if (FileSize==-1)
                {
                        Memo_Output->Lines->Add("Read File Error.");
                        close(handle);
                        free(pFileBuf);
                        return;
                }
                close(handle);
                #ifdef HY_Debug
                Memo_Output->Lines->Add(IntStrToHexString(pFileBuf+0xF7F0,16));
                Memo_Output->Lines->Add(IntStrToHexString(HengYu,16));
                #endif
                if (memcmp(pFileBuf+0xF7F0,HengYu,16)!=0)
                {
                        Memo_Output->Lines->Add("File Error,Not HengYu's File .");
                        free(pFileBuf);
                        return;
                }
                memcpy(m_CriticalDownload.DownloadBuffer,pFileBuf,FileSize);
                m_CriticalDownload.DownloadSize=FileSize;
                free(pFileBuf);
        } else return;
        m_OpenFilePath=OpenDlg_DownFile->FileName;

        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Text="";
        if (ProcessForm!=NULL)
        {
                ProcessForm->Lb_Caption->Caption="Chip erase processing...";
                ProcessForm->ProcessProgressBar->Max=0xF7FF;
                ProcessForm->ProcessProgressBar->Position=0;
                ProcessForm->Show();
                ProcessForm->Update();
        }

        if (HYMIFARE_EnterISP())
        {
                #ifdef HY_Debug
                Memo_Output->Lines->Add("Enter-ISP command send success.");
                #endif
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Enter-ISP command send fail.");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ExitClick(TObject *Sender)
{
        Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MainMenu_COM_ConnectClick(TObject *Sender)
{
        ToolButton_ClearClick(NULL);
        if (Connection(Handle,WM_MY_COMM_CMDLINE))
        {
                m_ConnectFlag=true;
                StatusBar_Main->Panels->Items[0]->Text="Connected";
                ToolButton_Disconnect->Enabled=m_ConnectFlag;
                ToolButton_Connect->Enabled=!m_ConnectFlag;
                MainMenu_COM_Disconnect->Enabled=m_ConnectFlag;
                MainMenu_COM_Connect->Enabled=!m_ConnectFlag;
                //SettingForm->BitBtn_OK->Click();
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MainMenu_COM_DisconnectClick(TObject *Sender)
{
        ToolButton_ClearClick(NULL);
        Disconnection(); 
        m_ConnectFlag=false;
        StatusBar_Main->Panels->Items[0]->Text="Disconnected";
        ToolButton_Disconnect->Enabled=m_ConnectFlag;
        ToolButton_Connect->Enabled=!m_ConnectFlag;
        MainMenu_COM_Disconnect->Enabled=m_ConnectFlag;
        MainMenu_COM_Connect->Enabled=!m_ConnectFlag;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MainMenu_COM_SettingClick(TObject *Sender)
{
        SettingForm->ShowModal();        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
        m_ConnectFlag=false;
        m_OpenFilePath="";
        m_EnterISPFlag=false;
        #ifdef HY_Test
        m_Sector=7;
        #else
        m_Sector=0;
        #endif
        m_Type=0xAA;
        m_KeyNum=0;
        m_ReadBlock=0;
        m_WriteBlock=0;

        m_ReadValueBlock=0;
        m_WriteValueBlock=0;

        m_IncrementBlock=0;
        m_DecrementBlock=0;

        m_CopySBlock=0;
        m_CopyDBlock=0;

        m_SAMID=1;

        for (int i=0;i<250;i++)
                m_TestBuf[i]=(250-i) & 0xff;
        m_ReSendCount=0;

        //GetOpenFilePathFromIni("FilePath.ini");
        GetSerialPortValueFromIni("SerialPort.ini");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
        if (m_ConnectFlag)
                Disconnection();
        UpdateSerialPortValueToIni("SerialPort.ini");
        //UpdateOpenFilePathToIni("FilePath.ini");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ToolButton_ClearClick(TObject *Sender)
{
        Memo_Output->Text="";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MainMenu_Help_AboutClick(TObject *Sender)
{
        AboutForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TreeView_ReadDblClick(TObject *Sender)
{
        for (int j = 0; j <TreeView_Read->Items->Count; j++)
        {
                if (TreeView_Read->Items->Item[j]->Selected)
                {
                        if ((j==0)||(j==1)||(j==12)||(j==23)||
                           (j==34)||(j==45)||(j==56)||(j==67))
                               return;
                        int i;
                        if (j<12)
                                i=j-2;
                        else if((j>=12)&&(j<23))
                                i=j-3;
                        else if((j>=23)&&(j<34))
                                i=j-4;
                        else if((j>=34)&&(j<45))
                                i=j-5;
                        else if((j>=45)&&(j<56))
                                i=j-6;
                        else if((j>=56)&&(j<67))
                                i=j-7;
                        else if((j>=67)&&(j<88))
                                i=j-8;
                        if (!m_ConnectFlag)
                        {
                                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                                return;
                        }
                        bool ret=HYMIFARE_ContinuousRead(i);
                        if (ret)
                        {
                                Memo_Output->Lines->Add("Send command success.");
                                Memo_Output->Lines->Add("Please place a card above RF field. ");
                                Timer_Timeout->Enabled=true;
                        }
                        else
                                Memo_Output->Lines->Add("Send command fail.");
                        return;
                }
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
        ComboBox_LoginSector->ItemIndex=0;
        ComboBox_LoginKeyType->ItemIndex=0;

        ComboBox_ReadBlock->ItemIndex=0;
        ComboBox_WriteBlock->ItemIndex=0;

        ComboBox_ReadValueBlock->ItemIndex=0;
        ComboBox_WriteValueBlock->ItemIndex=0;

        ComboBox_IncrementBlock->ItemIndex=0;
        ComboBox_DecrementBlock->ItemIndex=0;

        ComboBox_CopySBlock->ItemIndex=0;
        ComboBox_CopyDBlock->ItemIndex=0;

        SettingForm->BitBtn_OK->Click();
        ToolButton_Connect->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_SelectClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first. ");
                return;
        }
        Memo_Output->Lines->Add("Select...");
        bool ret=HYMIFARE_SelectCard();
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Btn_GetATSClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Edit_ATS->Text="";
        bool ret=HYMIFARE_GetATS();
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Btn_ExchangeClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Exchange APDU...");
        int bufLen;
        Byte *pBuf=(Byte *)malloc(256);
        if (pBuf==NULL)
        {
                Memo_Output->Lines->Add("Not enough memory to allocate buffer.");
                return;
        }
        if (!ProcessInputData(Edit_APDU,pBuf,bufLen))
        {
                Memo_Output->Lines->Add("Data input error.");
                free(pBuf);
                return;
        }
        //Memo_Output->Lines->Add(IntStrToIndexHexString(pBuf,0,16));
        Edit_APDUReturn->Text="";
        bool ret=HYMIFARE_ExchangeAPDU(pBuf,bufLen);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");

        free(pBuf);
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Btn_DeselectClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        bool ret=HYMIFARE_Deselect();
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_LoginClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Login...");
        int bufLen;
        Byte *pBuf=(Byte *)malloc(256);
        if (pBuf==NULL)
        {
                Memo_Output->Lines->Add("Not enough memory to allocate buffer.");
                return;
        }
        if (!ProcessInputData(Edit_LoginKey,pBuf,bufLen))
        {
                Memo_Output->Lines->Add("Type data input error.");
                free(pBuf);
                return;
        }
        bool ret=HYMIFARE_LoginSector(m_Sector,m_Type,pBuf);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        free(pBuf);

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_ReadClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Read...");
        bool ret=HYMIFARE_ReadDataBlock(m_ReadBlock);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_WriteClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        if (m_WriteBlock==0)
        {
                Memo_Output->Lines->Add("Sorry,this block can not write.");
                return;
        }
        Memo_Output->Lines->Add("Write...");
        int bufLen;
        Byte *pBuf=(Byte *)malloc(1024);
        if (pBuf==NULL)
        {
                Memo_Output->Lines->Add("Not enough memory to allocate buffer.");
                return;
        }
        if (!ProcessInputData(Edit_WriteData,pBuf,bufLen))
        {
                Memo_Output->Lines->Add("Data input error.");
                free(pBuf);
                return;
        }
        if (bufLen<16)
                for (int i=bufLen;i<16;i++)
                        pBuf[i]=0;
        //Memo_Output->Lines->Add(IntStrToIndexHexString(pBuf,0,16));

        bool ret=HYMIFARE_WriteDataBlock(m_WriteBlock,pBuf);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");

        free(pBuf);

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_ReadValueClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Read Value...");
        bool ret=HYMIFARE_ReadValueBlock(m_ReadValueBlock);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_WriteValueClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        if (m_WriteValueBlock==0)
        {
                Memo_Output->Lines->Add("Sorry,this block can not write.");
                return;
        }
        Memo_Output->Lines->Add("Write Value...");
        long bufLen;
        try
        {
                bufLen=StrToInt(Edit_WriteValueData->Text);
                //Memo_Output->Lines->Add(IntToStr(bufLen));
        }
        catch(...)
        {
                Memo_Output->Lines->Add("Sorry,input data error.");
                Edit_WriteValueData->Text="0";
                Edit_WriteValueData->SetFocus();
                return;
        }

        Byte iBuf[4],iBuffer[4];
        memcpy(iBuffer,&bufLen,sizeof(long));

        iBuf[0]=iBuffer[3];
        iBuf[1]=iBuffer[2];
        iBuf[2]=iBuffer[1];
        iBuf[3]=iBuffer[0];

        //Memo_Output->Lines->Add(IntStrToIndexHexString(iBuf,0,16));

        bool ret=HYMIFARE_WriteValueBlock(m_WriteValueBlock,iBuf);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_IncrementClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        if (m_WriteValueBlock==0)
        {
                Memo_Output->Lines->Add("Sorry,this block can not write.");
                return;
        }
        Memo_Output->Lines->Add("Increment Value...");
        long bufLen;
        try
        {
                bufLen=StrToInt(Edit_IncrementData->Text);
                if (bufLen<0)
                {
                        Memo_Output->Lines->Add("Sorry,input data must be positive");
                        Edit_IncrementData->Text="0";
                        Edit_IncrementData->SetFocus();
                        return;
                }
        }
        catch(...)
        {
                Memo_Output->Lines->Add("Sorry,input data error.");
                Edit_IncrementData->Text="0";
                Edit_IncrementData->SetFocus();
                return;
        }
        m_WriteData=bufLen;

        Byte iBuf[4],iBuffer[4];
        memcpy(iBuffer,&bufLen,sizeof(long));

        iBuf[0]=iBuffer[3];
        iBuf[1]=iBuffer[2];
        iBuf[2]=iBuffer[1];
        iBuf[3]=iBuffer[0];
        //Memo_Output->Lines->Add(IntStrToIndexHexString(iBuf,0,16));
        memcpy(m_WriteBuffer,iBuf,4);
        m_IncFlag=true;

        bool ret=HYMIFARE_ReadValueBlock(m_IncrementBlock);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        /*
        bool ret=HYMIFARE_IncrementValue(m_IncrementBlock,iBuf);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        */
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_DecrementClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        if (m_WriteValueBlock==0)
        {
                Memo_Output->Lines->Add("Sorry,this block can not write.");
                return;
        }
        Memo_Output->Lines->Add("Decrement Value...");
        long bufLen;
        try
        {
                bufLen=StrToInt(Edit_DecrementData->Text);
                if (bufLen<0)
                {
                        Memo_Output->Lines->Add("Sorry,input data must be positive");
                        Edit_DecrementData->Text="0";
                        Edit_DecrementData->SetFocus();
                }
        }
        catch(...)
        {
                Memo_Output->Lines->Add("Sorry,input data error.");
                Edit_DecrementData->Text="0";
                Edit_DecrementData->SetFocus();
                return;
        }
        m_WriteData=bufLen;

        Byte iBuf[4],iBuffer[4];
        memcpy(iBuffer,&bufLen,sizeof(long));

        iBuf[0]=iBuffer[3];
        iBuf[1]=iBuffer[2];
        iBuf[2]=iBuffer[1];
        iBuf[3]=iBuffer[0];
        //Memo_Output->Lines->Add(IntStrToIndexHexString(iBuf,0,16));
        memcpy(m_WriteBuffer,iBuf,4);
        m_DecFlag=true;

        bool ret=HYMIFARE_ReadValueBlock(m_DecrementBlock);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");

        /*bool ret=HYMIFARE_DecrementValue(m_DecrementBlock,iBuf);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");*/
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_WriteKeyClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Write key...");
        int bufLen;
        Byte *pBuf=(Byte *)malloc(2048);
        if (pBuf==NULL)
        {
                Memo_Output->Lines->Add("Not enough memory to allocate buffer.");
                return;
        }
        if (!ProcessInputData(Edit_WriteKeyData,pBuf,bufLen))
        {
                Memo_Output->Lines->Add("Data input error.");
                free(pBuf);
                return;
        }
        Memo_Output->Lines->Add("Sector:"+IntToHex(m_Sector,2));
        Memo_Output->Lines->Add(IntStrToHexString(pBuf,6));
        bool ret=HYMIFARE_WriteMasterKey(m_Sector,pBuf);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        free(pBuf);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_CopyClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        if (m_CopyDBlock==0)
        {
                Memo_Output->Lines->Add("Sorry,this block can not write.");
                return;
        }
        Memo_Output->Lines->Add("Copy...");
        bool ret=HYMIFARE_CopyValue(m_CopySBlock,m_CopyDBlock);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_HaltClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        bool ret=HYMIFARE_Halt();
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Timer_TimeoutTimer(TObject *Sender)
{
        if (ProcessForm!=NULL)
                ProcessForm->Btn_Cancel->Click();
        ProcessTimer->Enabled=false;
        Timer_Timeout->Enabled=false;
        m_IncFlag=false;
        m_DecFlag=false;
        m_EnterISPFlag=false;
        Memo_Output->Lines->Add("Timeout.");
}
//---------------------------------------------------------------------------
void TMainForm::ButtonEnable(bool flag)
{
        Button_Read->Enabled=flag;
        Button_Write->Enabled=flag;
        Button_ReadValue->Enabled=flag;
        Button_WriteValue->Enabled=flag;
        Button_Increment->Enabled=flag;
        Button_Decrement->Enabled=flag;
        Button_WriteKey->Enabled=flag;
        Button_Copy->Enabled=flag;
}
//---------------------------------------------------------------------------
void TMainForm::ShowErrorMessage(Byte iError)
{
        switch(iError)
        {
                case STATUS_OperationSuccess://0x00
                        Memo_Output->Lines->Add("Operation success.");
                break;
                case STATUS_NoTag://0x01
                        Memo_Output->Lines->Add("No tag.");
                break;
                case STATUS_LoginSuccess://0x02
                        Memo_Output->Lines->Add("Login success.");
                break;
                case STATUS_LoginFail://0x03
                        Memo_Output->Lines->Add("Login fail.");
                break;
                case STATUS_ReadFail://0x04
                        Memo_Output->Lines->Add("Read fail.");
                break;
                case STATUS_WriteFail://0x05
                        Memo_Output->Lines->Add("Write fail.");
                break;
                case STATUS_UnableReadAfterWrite://0x06
                        Memo_Output->Lines->Add("Unable to read after write.");
                break;
                case STATUS_ReadAfterWriteError://0x07
                        Memo_Output->Lines->Add("Read after write error.");
                break;
                case STATUS_ResetFail://0x08
                        Memo_Output->Lines->Add("Reset fail.");
                break;
                case STATUS_HaltFail://0x09
                        Memo_Output->Lines->Add("Halt fail.");
                break;
                case STATUS_CollisionOccur://0x0A
                        Memo_Output->Lines->Add("Collision occur.");
                break;
                case STATUS_NoSAK://0x0B
                        Memo_Output->Lines->Add("No SAK.");
                break;
                case STATUS_LoadKeyFail://0x0C
                        Memo_Output->Lines->Add("Load key fail.");
                break;
                case STATUS_NotAuthenticate://0x0D
                        Memo_Output->Lines->Add("Not authenticate.");
                break;
                case STATUS_NotAValueBlock://0x0E
                        Memo_Output->Lines->Add("Not avalue block.");
                break;
                case STATUS_UnableToHalt://0x0F
                        Memo_Output->Lines->Add("Unable to halt.");
                break;

                case STATUS_AccessDenied://0x10
                        Memo_Output->Lines->Add("Access denied.");
                break;
                case STATUS_InvalidATS://0x11
                        Memo_Output->Lines->Add("Invalid ATS.");
                break;

                case STATUS_EEPROMAccessError://0x12
                        Memo_Output->Lines->Add("EEPROM access error.");
                break;
                case STATUS_KeySlotNumberOutOfRange://0x13
                        Memo_Output->Lines->Add("Key number out of range.");
                break;
                case STATUS_EEPROMDataOutOfRange://0x14
                        Memo_Output->Lines->Add("Data number out of range.");
                break;
                case STATUS_SectorOutOfRange://0x20
                        Memo_Output->Lines->Add("Sector out of range.");
                break;
                case STATUS_InvalidKeyType://0x21
                        Memo_Output->Lines->Add("Invalid key type.");
                break;
                case STATUS_BlockOutOfRange://0x22
                        Memo_Output->Lines->Add("Block out of range.");
                break;
                case STATUS_BaudRateOutOfRange://0x23
                        Memo_Output->Lines->Add("Baud rate out of range.");
                break;
                case STATUS_NoSmartCard://0x2B
                        Memo_Output->Lines->Add("No smart card.");
                break;

                case STATUS_ProgramError://0x30
                        Memo_Output->Lines->Add("Program error.");
                break;
                case STATUS_VerifyError://0x31
                        Memo_Output->Lines->Add("Verify error.");
                break;

                case STATUS_ChecksumError:
                        Memo_Output->Lines->Add("Checksum error.");
                break;
                case STATUS_InvalidCommand:
                        Memo_Output->Lines->Add("Invalid command.");
                break;
                case STATUS_CommunicationLineError:
                        Memo_Output->Lines->Add("Communication line error.");
                break;
                case STATUS_UnknownError:
                default:
                        Memo_Output->Lines->Add("Unknown Status.");
        }
}

void __fastcall TMainForm::ComboBox_LoginSectorChange(TObject *Sender)
{
        unsigned char buf[3],buff[3];
        int i;

        ComboBox_LoginSector->GetTextBuf(buf,3);
        StringToHexStr(buf,buff);
        m_Sector=buff[0];

        ComboBox_ReadBlock->Clear();
        ComboBox_WriteBlock->Clear();

        ComboBox_ReadValueBlock->Clear();
        ComboBox_WriteValueBlock->Clear();

        ComboBox_IncrementBlock->Clear();
        ComboBox_DecrementBlock->Clear();

        ComboBox_CopySBlock->Clear();
        ComboBox_CopyDBlock->Clear();

        m_ReadBlock=m_Sector*3+m_Sector;
        m_WriteBlock=m_ReadBlock;

        m_ReadValueBlock=m_ReadBlock;
        m_WriteValueBlock=m_ReadBlock;

        m_IncrementBlock=m_ReadBlock;
        m_DecrementBlock=m_ReadBlock;

        m_CopySBlock=m_ReadBlock;
        m_CopyDBlock=m_ReadBlock;

        for (i=m_ReadBlock;i<4+m_ReadBlock;i++)
        {
                ComboBox_ReadBlock->Items->Add(IntToHexString(i));
                ComboBox_ReadValueBlock->Items->Add(IntToHexString(i));
        }
        for (i=m_ReadBlock;i<4/*3*/+m_ReadBlock;i++)
        {
                ComboBox_WriteBlock->Items->Add(IntToHexString(i));
                ComboBox_WriteValueBlock->Items->Add(IntToHexString(i));
                ComboBox_IncrementBlock->Items->Add(IntToHexString(i));
                ComboBox_DecrementBlock->Items->Add(IntToHexString(i));
                ComboBox_CopySBlock->Items->Add(IntToHexString(i));
                ComboBox_CopyDBlock->Items->Add(IntToHexString(i));
        }
        ComboBox_ReadBlock->ItemIndex=0;
        ComboBox_WriteBlock->ItemIndex=0;
        ComboBox_ReadValueBlock->ItemIndex=0;
        ComboBox_WriteValueBlock->ItemIndex=0;

        ComboBox_IncrementBlock->ItemIndex=0;
        ComboBox_DecrementBlock->ItemIndex=0;
        ComboBox_CopySBlock->ItemIndex=0;
        ComboBox_CopyDBlock->ItemIndex=0;

        //Memo_Output->Lines->Add(IntToStr(m_ReadBlock));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_ReadBlockChange(TObject *Sender)
{
        unsigned char buf[3],buff[3];

        ComboBox_ReadBlock->GetTextBuf(buf,3);
        StringToHexStr(buf,buff);

        m_ReadBlock=buff[0];
        //Memo_Output->Lines->Add(IntToStr(m_ReadBlock));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_WriteBlockChange(TObject *Sender)
{
        unsigned char buf[3],buff[3];

        ComboBox_WriteBlock->GetTextBuf(buf,3);
        StringToHexStr(buf,buff);

        m_WriteBlock=buff[0];
        //Memo_Output->Lines->Add(IntToStr(m_WriteBlock));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_ReadValueBlockChange(TObject *Sender)
{
        unsigned char buf[3],buff[3];

        ComboBox_ReadValueBlock->GetTextBuf(buf,3);
        StringToHexStr(buf,buff);

        m_ReadValueBlock=buff[0];
        //Memo_Output->Lines->Add(IntToStr(m_ReadValueBlock));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_WriteValueBlockChange(TObject *Sender)
{
        unsigned char buf[3],buff[3];

        ComboBox_WriteValueBlock->GetTextBuf(buf,3);
        StringToHexStr(buf,buff);

        m_WriteValueBlock=buff[0];
        //Memo_Output->Lines->Add(IntToStr(m_WriteValueBlock));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_IncrementBlockChange(TObject *Sender)
{
        unsigned char buf[3],buff[3];

        ComboBox_IncrementBlock->GetTextBuf(buf,3);
        StringToHexStr(buf,buff);

        m_IncrementBlock=buff[0];
        //Memo_Output->Lines->Add(IntToStr(m_IncrementBlock));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_DecrementBlockChange(TObject *Sender)
{
        unsigned char buf[3],buff[3];

        ComboBox_DecrementBlock->GetTextBuf(buf,3);
        StringToHexStr(buf,buff);

        m_DecrementBlock=buff[0];
        //Memo_Output->Lines->Add(IntToStr(m_DecrementBlock));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_CopySBlockChange(TObject *Sender)
{
        unsigned char buf[3],buff[3];

        ComboBox_CopySBlock->GetTextBuf(buf,3);
        StringToHexStr(buf,buff);

        m_CopySBlock=buff[0];
        //Memo_Output->Lines->Add(IntToStr(m_CopySBlock));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_CopyDBlockChange(TObject *Sender)
{
        unsigned char buf[3],buff[3];

        ComboBox_CopyDBlock->GetTextBuf(buf,3);
        StringToHexStr(buf,buff);

        m_CopyDBlock=buff[0];
        //Memo_Output->Lines->Add(IntToStr(m_CopyDBlock));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_LoginKeyTypeChange(TObject *Sender)
{
        if (ComboBox_LoginKeyType->ItemIndex)
                m_Type=0xbb;
        else
                m_Type=0xaa;
        //Memo_Output->Lines->Add(IntToStr(m_Type));
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button1Click(TObject *Sender)
{
        if (HYMIFARE_ChipErase())
        {
                Memo_Output->Lines->Add("Chip-erase command send success.");
                ProcessTimer->Enabled=true;
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Chip-erase command send fail.");

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ProcessTimerTimer(TObject *Sender)
{
        ProcessTimer->Enabled=false;
        Memo_Output->Text = Memo_Output->Text + ". ";
        ProcessTimer->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button3Click(TObject *Sender)
{
        if (HYMIFARE_PageErase(12))
        {
                Memo_Output->Lines->Add("Page-erase command send success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Page-erase command send fail.");

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button2Click(TObject *Sender)
{
        Byte buf[250];
        for (int i=0;i<250;i++)
                buf[i]=i;
        if (HYMIFARE_ByteProgram(0,buf,250))
        {
                Memo_Output->Lines->Add("Byte-program command send success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Byte-program command send fail.");

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ResetClick(TObject *Sender)
{
        if (HYMIFARE_Reset())
        {
                Memo_Output->Lines->Add("Reset command send success.");
                ProcessTimer->Enabled=true;
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Reset command send fail.");

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::LED_RedClick(TObject *Sender)
{
        if (HYMIFARE_IOOutput(1,LED_Red))
        {
                Memo_Output->Lines->Add("LED command send success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("LED command send fail.");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::LED_GreenClick(TObject *Sender)
{
        if (HYMIFARE_IOOutput(1,LED_Green))
        {
                Memo_Output->Lines->Add("LED command send success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("LED command send fail.");

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::LED_RedAndGreenClick(TObject *Sender)
{
        if (HYMIFARE_IOOutput(1,LED_RedAndGreen))
        {
                Memo_Output->Lines->Add("LED command send success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("LED command send fail.");

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::TurnoffClick(TObject *Sender)
{
        if (HYMIFARE_IOOutput(1,0xFF))
        {
                Memo_Output->Lines->Add("LED command send success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("LED command send fail.");

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button4Click(TObject *Sender)
{
        if (HYMIFARE_EnterISP())
        {
                //#ifdef HY_Debug
                Memo_Output->Lines->Add("Enter-ISP command send success.");
                //#endif
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Enter-ISP command send fail.");
        
}
//---------------------------------------------------------------------------



void __fastcall TMainForm::Btn_SmartCardPowerUpClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Edit_SmartCardATR->Text="";
        bool ret=HYMIFARE_SmartCardPowerUp(m_SAMID);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox_SAMIDChange(TObject *Sender)
{
        m_SAMID=ComboBox_SAMID->ItemIndex+1;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Btn_SmartCardPowerDownClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Edit_SmartCardATR->Text="";
        bool ret=HYMIFARE_SmartCardPowerDown(m_SAMID);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Btn_SmartCardExchangeAPDUClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Exchange APDU...");
        int bufLen;
        Byte *pBuf=(Byte *)malloc(256);
        if (pBuf==NULL)
        {
                Memo_Output->Lines->Add("Not enough memory to allocate buffer.");
                return;
        }
        if (!ProcessInputData(Edit_SmartCardAPDU,pBuf,bufLen))
        {
                Memo_Output->Lines->Add("Data input error.");
                free(pBuf);
                return;
        }
        //Memo_Output->Lines->Add(IntStrToIndexHexString(pBuf,0,bufLen));
        Edit_SmartCardAPDUReturn->Text="";
        bool ret=HYMIFARE_SmartCardExchangeAPDU(m_SAMID,pBuf,bufLen);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");

        free(pBuf);

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button_ReadTestClick(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Read...");
        HYMIFARE_ReadData(0,250);
        HYMIFARE_ReadData(250,250);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button10Click(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Byte buff[250];
        for (int i=0;i<250;i++)
            buff[i]=i & 0xff;
        Memo_Output->Lines->Add("Write...");
        m_ReSendCount=0;
        HYMIFARE_WriteData(0,buff,250);

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::cmbChangeBaudChange(TObject *Sender)
{
     	HY_ChangeBaudRate(cmbChangeBaud->ItemIndex);
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::Button8Click(TObject *Sender)
{
	 HY_MIFARE_RequestMifareCard(NULL);        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button6Click(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Login...");
        int bufLen;
        Byte *pBuf=(Byte *)malloc(256);
        if (pBuf==NULL)
        {
                Memo_Output->Lines->Add("Not enough memory to allocate buffer.");
                return;
        }
        if (!ProcessInputData(Edit_LoginKey,pBuf,bufLen))
        {
                Memo_Output->Lines->Add("Type data input error.");
                free(pBuf);
                return;
        }
        bool ret=HY_MIFARE_AutoLogin(m_Sector,m_Type,pBuf);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        free(pBuf);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button7Click(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Store...");
        int bufLen;
        Byte *pBuf=(Byte *)malloc(256);
        if (pBuf==NULL)
        {
                Memo_Output->Lines->Add("Not enough memory to allocate buffer.");
                return;
        }
        if (!ProcessInputData(Edit_LoginKey,pBuf,bufLen))
        {
                Memo_Output->Lines->Add("Type data input error.");
                free(pBuf);
                return;
        }
        bool ret=HY_MIFARE_StoreKey(m_KeyNum,pBuf);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
        free(pBuf);

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button9Click(TObject *Sender)
{
        if (!m_ConnectFlag)
        {
                Memo_Output->Lines->Add("It is disconnected,please connect first.");
                return;
        }
        Memo_Output->Lines->Add("Login...");
        bool ret=HY_MIFARE_LoginWithKeyStored(m_Sector,m_Type,m_KeyNum);
        if (ret)
        {
                Memo_Output->Lines->Add("Send command success.");
                Timer_Timeout->Enabled=true;
        }
        else
                Memo_Output->Lines->Add("Send command fail.");
       
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBox1Change(TObject *Sender)
{
     	m_KeyNum= ComboBox1->ItemIndex;
}
//---------------------------------------------------------------------------

