//---------------------------------------------------------------------------

#ifndef MainUnitH
#define MainUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------

#define WM_MY_COMM_CMDLINE (WM_USER+100) //̼ͨѶԶϢ

//״̬
#define DOWNLOAD_CONTINUE       0
#define DOWNLOAD_LASTBYTE       1
#define DOWNLOAD_FINISHED       2

#define MAXBUFSIZE      64*1024+1

//#define HY_Debug        1

typedef struct SerialPort
{
        int COM_Idx;
        int Baud_Idx;
        int Data_Idx;
        int Parity_Idx;
        int Stop_Idx;
}_COM232_;

typedef struct CriticalDownload
{
        int  DownloadState;

        long DownloadSize;
        long DownloadingSize;
        long DownloadRemainSize;
        long DownloadOffset;
        Byte DownloadBuffer[MAXBUFSIZE];
        Byte DownloadLastByte;
}_CD_;

//---------------------------------------------------------------------------

class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu_Main;
        TMenuItem *System;
        TMenuItem *Updatefirmware;
        TMenuItem *Reset;
        TMenuItem *N2;
        TMenuItem *Exit;
        TMenuItem *MainMenu_COM;
        TMenuItem *MainMenu_COM_Connect;
        TMenuItem *MainMenu_COM_Disconnect;
        TMenuItem *N3;
        TMenuItem *MainMenu_COM_Setting;
        TMenuItem *MainMenu_Help;
        TMenuItem *MainMenu_Help_About;
        TImageList *ImageList_Tool;
        TTimer *Timer_Timeout;
        TPanel *MainPanel;
        TPanel *ToolPanel;
        TStatusBar *StatusBar_Main;
        TPanel *ClientPanel;
        TOpenDialog *OpenDlg_DownFile;
        TToolBar *ToolBar_Main;
        TToolButton *ToolButton2;
        TToolButton *ToolButton_Connect;
        TToolButton *ToolButton3;
        TToolButton *ToolButton_Disconnect;
        TToolButton *ToolButton1;
        TToolButton *ToolButton_Setting;
        TToolButton *ToolButton5;
        TToolButton *ToolButton_Clear;
        TToolButton *ToolButton4;
        TToolButton *ToolButton_Exit;
        TToolButton *ToolButton14;
        TPanel *Panel_Left;
        TTreeView *TreeView_Read;
        TSplitter *Splitter_Left;
        TPanel *RightPanel;
        TPanel *RightTopPanel;
        TSplitter *Splitter_Client;
        TPanel *Panel_Right_Bottom;
        TMemo *Memo_Output;
        TPanel *Panel_Right_Top_Client;
        TTimer *ProcessTimer;
        TMenuItem *N4;
        TMenuItem *LED;
        TMenuItem *LED_Red;
        TMenuItem *LED_Green;
        TMenuItem *LED_RedAndGreen;
        TMenuItem *Turnoff;
        TMenuItem *N1;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TTabSheet *TabSheet3;
        TPanel *Panel1;
        TPanel *Panel_Mifare;
        TLabel *Label1;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label11;
        TLabel *Label12;
        TLabel *Label15;
        TLabel *Label16;
        TLabel *Label6;
        TLabel *Label10;
        TLabel *Label18;
        TLabel *Label13;
        TLabel *Label3;
        TLabel *Label17;
        TLabel *Label2;
        TButton *Button_Login;
        TButton *Button_Read;
        TButton *Button_Write;
        TButton *Button_ReadValue;
        TButton *Button_WriteValue;
        TButton *Button_Increment;
        TButton *Button_Decrement;
        TButton *Button_WriteKey;
        TButton *Button_Copy;
        TButton *Button_Halt;
        TComboBox *ComboBox_LoginSector;
        TComboBox *ComboBox_ReadBlock;
        TComboBox *ComboBox_WriteBlock;
        TComboBox *ComboBox_ReadValueBlock;
        TComboBox *ComboBox_WriteValueBlock;
        TComboBox *ComboBox_IncrementBlock;
        TComboBox *ComboBox_DecrementBlock;
        TComboBox *ComboBox_LoginKeyType;
        TEdit *Edit_WriteKeyData;
        TComboBox *ComboBox_CopySBlock;
        TEdit *Edit_WriteData;
        TEdit *Edit_WriteValueData;
        TEdit *Edit_IncrementData;
        TEdit *Edit_DecrementData;
        TComboBox *ComboBox_CopyDBlock;
        TEdit *Edit_LoginKey;
        TPanel *Panel2;
        TPanel *Panel_MifarePro;
        TLabel *Label7;
        TButton *Btn_GetATS;
        TEdit *Edit_ATS;
        TEdit *Edit_APDU;
        TButton *Btn_Exchange;
        TEdit *Edit_APDUReturn;
        TButton *Btn_Deselect;
        TPanel *Panel3;
        TPanel *Panel_SmartCard;
        TLabel *Label14;
        TLabel *Label19;
        TButton *Btn_SmartCardPowerUp;
        TEdit *Edit_SmartCardATR;
        TEdit *Edit_SmartCardAPDU;
        TButton *Btn_SmartCardExchangeAPDU;
        TEdit *Edit_SmartCardAPDUReturn;
        TButton *Btn_SmartCardPowerDown;
        TComboBox *ComboBox_SAMID;
        TPanel *Panel_Select;
        TLabel *Label_CardType;
        TButton *Button_Select;
        TButton *Button1;
        TButton *Button2;
        TButton *Button3;
        TButton *Button4;
        TPanel *Panel4;
        TLabel *Label20;
        TButton *Button5;
        TPanel *Panel5;
        TLabel *Label21;
        TButton *Button8;
        TButton *Button6;
        TButton *Button7;
        TButton *Button9;
        TButton *Button10;
        TButton *Button11;
        TButton *Button16;
        TLabel *Label22;
        TComboBox *ComboBox1;
        TTabSheet *TabSheet4;
        TPanel *Panel6;
        TPanel *Panel7;
        TPanel *Panel8;
        TLabel *Label25;
        TButton *Button20;
        TButton *Button21;
        TButton *Button22;
        TButton *Button23;
        TGroupBox *GroupBox1;
        TComboBox *cmbChangeBaud;
        void __fastcall UpdatefirmwareClick(TObject *Sender);
        void __fastcall ExitClick(TObject *Sender);
        void __fastcall MainMenu_COM_ConnectClick(TObject *Sender);
        void __fastcall MainMenu_COM_DisconnectClick(TObject *Sender);
        void __fastcall MainMenu_COM_SettingClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall ToolButton_ClearClick(TObject *Sender);
        void __fastcall MainMenu_Help_AboutClick(TObject *Sender);
        void __fastcall TreeView_ReadDblClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall Button_SelectClick(TObject *Sender);
        void __fastcall Btn_GetATSClick(TObject *Sender);
        void __fastcall Btn_ExchangeClick(TObject *Sender);
        void __fastcall Btn_DeselectClick(TObject *Sender);
        void __fastcall Button_LoginClick(TObject *Sender);
        void __fastcall Button_ReadClick(TObject *Sender);
        void __fastcall Button_WriteClick(TObject *Sender);
        void __fastcall Button_ReadValueClick(TObject *Sender);
        void __fastcall Button_WriteValueClick(TObject *Sender);
        void __fastcall Button_IncrementClick(TObject *Sender);
        void __fastcall Button_DecrementClick(TObject *Sender);
        void __fastcall Button_WriteKeyClick(TObject *Sender);
        void __fastcall Button_CopyClick(TObject *Sender);
        void __fastcall Button_HaltClick(TObject *Sender);
        void __fastcall Timer_TimeoutTimer(TObject *Sender);
        void __fastcall ComboBox_LoginSectorChange(TObject *Sender);
        void __fastcall ComboBox_ReadBlockChange(TObject *Sender);
        void __fastcall ComboBox_WriteBlockChange(TObject *Sender);
        void __fastcall ComboBox_ReadValueBlockChange(TObject *Sender);
        void __fastcall ComboBox_WriteValueBlockChange(TObject *Sender);
        void __fastcall ComboBox_IncrementBlockChange(TObject *Sender);
        void __fastcall ComboBox_DecrementBlockChange(TObject *Sender);
        void __fastcall ComboBox_CopySBlockChange(TObject *Sender);
        void __fastcall ComboBox_CopyDBlockChange(TObject *Sender);
        void __fastcall ComboBox_LoginKeyTypeChange(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall ProcessTimerTimer(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall ResetClick(TObject *Sender);
        void __fastcall LED_RedClick(TObject *Sender);
        void __fastcall LED_GreenClick(TObject *Sender);
        void __fastcall LED_RedAndGreenClick(TObject *Sender);
        void __fastcall TurnoffClick(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall Btn_SmartCardPowerUpClick(TObject *Sender);
        void __fastcall ComboBox_SAMIDChange(TObject *Sender);
        void __fastcall Btn_SmartCardPowerDownClick(TObject *Sender);
        void __fastcall Btn_SmartCardExchangeAPDUClick(TObject *Sender);
        void __fastcall Button_ReadTestClick(TObject *Sender);
        void __fastcall Button10Click(TObject *Sender);
        void __fastcall cmbChangeBaudChange(TObject *Sender);
        void __fastcall Button8Click(TObject *Sender);
        void __fastcall Button6Click(TObject *Sender);
        void __fastcall Button7Click(TObject *Sender);
        void __fastcall Button9Click(TObject *Sender);
        void __fastcall ComboBox1Change(TObject *Sender);
private:	// User declarations
        long m_WriteData;
        Byte m_WriteBuffer[4];
        bool m_IncFlag;
        bool m_DecFlag;

        //Byte m_FileBuffer[MAXBUFSIZE];
        long m_FileSize;
        bool m_FileOpenFlag;
protected:
//ϢӦ
        void __fastcall MessageProcess(TMessage Message);
public:		// User declarations
        bool m_ConnectFlag;
        bool m_CancelFlag;

        bool m_EnterISPFlag;
        
        AnsiString m_OpenFilePath;

        SerialPort m_SerialPort;
        CriticalDownload m_CriticalDownload;

        Byte m_Sector;
        Byte m_Type;
        Byte m_KeyNum;

        Byte m_ReadBlock;
        Byte m_WriteBlock;

        Byte m_ReadValueBlock;
        Byte m_WriteValueBlock;

        Byte m_IncrementBlock;
        Byte m_DecrementBlock;

        Byte m_CopySBlock;
        Byte m_CopyDBlock;

        int  m_SAMID;

        Byte m_TestBuf[250];
        int  m_ReSendCount;

        void ButtonEnable(bool flag);
        void ShowErrorMessage(Byte iError);
        __fastcall TMainForm(TComponent* Owner);

//ͨ궨ʵϢȷӦ
BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_MY_COMM_CMDLINE, TMessage, MessageProcess)
END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
