//---------------------------------------------------------------------------
#include <vcl.h>
#include <io.h>
#include <alloc.h>
#include <fcntl.h>
#include <process.h>
#include <sys\stat.h>


#include <Registry.hpp>
#include <Inifiles.hpp>
#pragma hdrstop

#include "RegisterUnit.h"
#include "MainUnit.h"
#include "Run/Func.h"
#include "SettingUnit.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
//---------------------------------------------------------------------------

void GetSerialPortValue(AnsiString KeyName)
{
        TRegistry *Registry = new TRegistry;
        try
        {
                Registry->RootKey = HKEY_LOCAL_MACHINE;
                if (Registry->OpenKey(KeyName,false))
                {
                        MainForm->m_SerialPort.COM_Idx=
                                Registry->ReadInteger("COM");
                        MainForm->m_SerialPort.Baud_Idx=
                                Registry->ReadInteger("Baud");
                        MainForm->m_SerialPort.Data_Idx=
                                Registry->ReadInteger("Data");
                        MainForm->m_SerialPort.Parity_Idx=
                                Registry->ReadInteger("Parity");
                        MainForm->m_SerialPort.Stop_Idx=
                                Registry->ReadInteger("Stop");
                }
                else
                {
                        Registry->OpenKey(KeyName,true);
                        Registry->WriteInteger("COM",COM1);
                        Registry->WriteInteger("Baud",BAUDR_2400);
                        Registry->WriteInteger("Data",DBIT_8);
                        Registry->WriteInteger("Parity",PARIT_NONE);
                        Registry->WriteInteger("Stop",STOPBITS_ONE);
                        MainForm->m_SerialPort.COM_Idx= COM1;
                        MainForm->m_SerialPort.Baud_Idx= BAUDR_2400;
                        MainForm->m_SerialPort.Data_Idx= DBIT_8;
                        MainForm->m_SerialPort.Parity_Idx= PARIT_NONE;
                        MainForm->m_SerialPort.Stop_Idx= STOPBITS_ONE;
                }
        }
        __finally
        {
                delete Registry;
        }
}
//---------------------------------------------------------------------------

void UpdateSerialPortValue(AnsiString KeyName)
{
        TRegistry *Registry = new TRegistry;
        try
        {
                Registry->RootKey = HKEY_LOCAL_MACHINE;
                if (Registry->OpenKey(KeyName,false))
                {
                        Registry->WriteInteger("COM",MainForm->m_SerialPort.COM_Idx);
                        Registry->WriteInteger("Baud",MainForm->m_SerialPort.Baud_Idx);
                        Registry->WriteInteger("Data",MainForm->m_SerialPort.Data_Idx);
                        Registry->WriteInteger("Parity",MainForm->m_SerialPort.Parity_Idx);
                        Registry->WriteInteger("Stop",MainForm->m_SerialPort.Stop_Idx);
                }
        }
        __finally
        {
                delete Registry;
        }
}
//---------------------------------------------------------------------------

void GetSerialPortValueFromIni(AnsiString IniName)
{
        AnsiString FileName=ExtractFilePath(ParamStr(0))+IniName;

        TIniFile *IniFile = new TIniFile(FileName);
        try
        {
                MainForm->m_SerialPort.COM_Idx=
                        IniFile->ReadInteger("COMM","COM",COM1);
                MainForm->m_SerialPort.Baud_Idx=
                        IniFile->ReadInteger("COMM","Baud",BAUDR_57600);
                MainForm->m_SerialPort.Data_Idx=
                        IniFile->ReadInteger("COMM","Data",DBIT_8);
                MainForm->m_SerialPort.Parity_Idx=
                        IniFile->ReadInteger("COMM","Parity",PARIT_NONE);
                MainForm->m_SerialPort.Stop_Idx=
                        IniFile->ReadInteger("COMM","Stop",STOPBITS_ONE);
                MainForm->m_OpenFilePath=
                        IniFile->ReadString("OpenFilePath","FilePath",FileName);
        }
        __finally
        {
                delete IniFile;
        }
}

void UpdateSerialPortValueToIni(AnsiString IniName)
{
        AnsiString FileName=ExtractFilePath(ParamStr(0))+IniName;
        
        TIniFile *IniFile = new TIniFile(FileName);
        try
        {
                IniFile->WriteInteger("COMM","COM",MainForm->m_SerialPort.COM_Idx);
                IniFile->WriteInteger("COMM","Baud",MainForm->m_SerialPort.Baud_Idx);
                IniFile->WriteInteger("COMM","Data",MainForm->m_SerialPort.Data_Idx);
                IniFile->WriteInteger("COMM","Parity",MainForm->m_SerialPort.Parity_Idx);
                IniFile->WriteInteger("COMM","Stop",MainForm->m_SerialPort.Stop_Idx);
                IniFile->WriteString("OpenFilePath","FilePath",MainForm->m_OpenFilePath);
        }
        __finally
        {
                delete IniFile;
        }
}

void GetOpenFilePathFromIni(AnsiString IniName)
{
        AnsiString FilePath=ExtractFilePath(ParamStr(0));
        AnsiString FileName=FilePath+IniName;

        TIniFile *IniFile = new TIniFile(FileName);
        try
        {
                MainForm->m_OpenFilePath=
                        IniFile->ReadString("OpenFilePath","FilePath",FilePath);
        }
        __finally
        {
                delete IniFile;
        }
}

void UpdateOpenFilePathToIni(AnsiString IniName)
{
        AnsiString FileName=ExtractFilePath(ParamStr(0))+IniName;

        TIniFile *IniFile = new TIniFile(FileName);
        try
        {
                IniFile->WriteString("OpenFilePath","FilePath",MainForm->m_OpenFilePath);
        }
        __finally
        {
                delete IniFile;
        }
}
//---------------------------------------------------------------------------

